> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Create an app

POST https://api.x.flatfile.com/v1/apps
Content-Type: application/json

Creates an app

Reference: https://reference.flatfile.com/api-reference/apps/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects an AppCreate.

- `name` (string, required)
- `namespace` (string, required)
- `type` (enum, required)
  - Allowed values: `PORTAL`, `PROJECTS`, `MAPPING`, `WORKBOOKS`, `CUSTOM`
- `entity` (string, optional)
- `entityPlural` (string, optional)
- `icon` (string, optional)
- `metadata` (any, optional)
- `environmentFilters` (any, optional)
- `blueprint` (any, optional)

## Response

### 200

- `data` (App, required) — An app

## Types

### App

An app

- `id` (string, required) — App ID
- `name` (string, required)
- `namespace` (string, required)
- `type` (enum, required)
  - Allowed values: `PORTAL`, `PROJECTS`, `MAPPING`, `WORKBOOKS`, `CUSTOM`
- `entity` (string, required)
- `entityPlural` (string, required)
- `metadata` (any, required)
- `environmentFilters` (any, required)
- `createdAt` (datetime, required)
- `updatedAt` (datetime, required)
- `icon` (string, optional)
- `blueprint` (any, optional)
- `deletedAt` (datetime, optional)
- `activatedAt` (datetime, optional)

## Examples

**Request**

```json
{
  "name": "Nightly Data Loads",
  "namespace": "nightly-data",
  "type": "CUSTOM",
  "entity": "Sync",
  "entityPlural": "Syncs",
  "icon": "<svg xmlns=\"http://www.w3.org/2000/svg\" fill=\"currentColor\" class=\"bi bi-bar-chart-fill\" viewBox=\"0 0 16 16\">\n  <path d=\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\"/>\n</svg>",
  "metadata": {
    "foo": "bar"
  }
}
```

**Response**

```json
{
  "data": {
    "id": "us_app_YOUR_ID",
    "name": "Nightly Data Loads",
    "namespace": "nightly-data",
    "type": "CUSTOM",
    "entity": "Sync",
    "entityPlural": "Syncs",
    "metadata": {
      "foo": "bar"
    },
    "environmentFilters": {
      "type": [
        "PROD",
        "DEV"
      ],
      "exclude_ids": [
        "us_env_123456"
      ]
    },
    "createdAt": "2023-10-30T16:59:45.735Z",
    "updatedAt": "2023-10-30T16:59:45.735Z",
    "icon": "<svg xmlns=\"http://www.w3.org/2000/svg\" fill=\"currentColor\" class=\"bi bi-bar-chart-fill\" viewBox=\"0 0 16 16\">\n  <path d=\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\"/>\n</svg>",
    "deletedAt": null,
    "activatedAt": null
  }
}
```

**SDK Code**

```python Example0
import requests

url = "https://api.x.flatfile.com/v1/apps"

payload = {
    "name": "Nightly Data Loads",
    "namespace": "nightly-data",
    "type": "CUSTOM",
    "entity": "Sync",
    "entityPlural": "Syncs",
    "icon": "<svg xmlns=\"http://www.w3.org/2000/svg\" fill=\"currentColor\" class=\"bi bi-bar-chart-fill\" viewBox=\"0 0 16 16\">
  <path d=\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\"/>
</svg>",
    "metadata": { "foo": "bar" }
}
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```typescript Example0
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.apps.create({
    name: "Nightly Data Loads",
    namespace: "nightly-data",
    type: "CUSTOM",
    entity: "Sync",
    entityPlural: "Syncs",
    icon: "<svg xmlns=\"http://www.w3.org/2000/svg\" fill=\"currentColor\" class=\"bi bi-bar-chart-fill\" viewBox=\"0 0 16 16\">\n  <path d=\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\"/>\n</svg>",
    metadata: {
        "foo": "bar"
    }
});

```

```go Example0
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/apps"

	payload := strings.NewReader("{\n  \"name\": \"Nightly Data Loads\",\n  \"namespace\": \"nightly-data\",\n  \"type\": \"CUSTOM\",\n  \"entity\": \"Sync\",\n  \"entityPlural\": \"Syncs\",\n  \"icon\": \"<svg xmlns=\\\"http://www.w3.org/2000/svg\\\" fill=\\\"currentColor\\\" class=\\\"bi bi-bar-chart-fill\\\" viewBox=\\\"0 0 16 16\\\">\\n  <path d=\\\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\\\"/>\\n</svg>\",\n  \"metadata\": {\n    \"foo\": \"bar\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example0
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/apps")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Nightly Data Loads\",\n  \"namespace\": \"nightly-data\",\n  \"type\": \"CUSTOM\",\n  \"entity\": \"Sync\",\n  \"entityPlural\": \"Syncs\",\n  \"icon\": \"<svg xmlns=\\\"http://www.w3.org/2000/svg\\\" fill=\\\"currentColor\\\" class=\\\"bi bi-bar-chart-fill\\\" viewBox=\\\"0 0 16 16\\\">\\n  <path d=\\\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\\\"/>\\n</svg>\",\n  \"metadata\": {\n    \"foo\": \"bar\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java Example0
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.x.flatfile.com/v1/apps")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Nightly Data Loads\",\n  \"namespace\": \"nightly-data\",\n  \"type\": \"CUSTOM\",\n  \"entity\": \"Sync\",\n  \"entityPlural\": \"Syncs\",\n  \"icon\": \"<svg xmlns=\\\"http://www.w3.org/2000/svg\\\" fill=\\\"currentColor\\\" class=\\\"bi bi-bar-chart-fill\\\" viewBox=\\\"0 0 16 16\\\">\\n  <path d=\\\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\\\"/>\\n</svg>\",\n  \"metadata\": {\n    \"foo\": \"bar\"\n  }\n}")
  .asString();
```

```php Example0
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.x.flatfile.com/v1/apps', [
  'body' => '{
  "name": "Nightly Data Loads",
  "namespace": "nightly-data",
  "type": "CUSTOM",
  "entity": "Sync",
  "entityPlural": "Syncs",
  "icon": "<svg xmlns=\\"http://www.w3.org/2000/svg\\" fill=\\"currentColor\\" class=\\"bi bi-bar-chart-fill\\" viewBox=\\"0 0 16 16\\">\\n  <path d=\\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\\"/>\\n</svg>",
  "metadata": {
    "foo": "bar"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Example0
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/apps");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Nightly Data Loads\",\n  \"namespace\": \"nightly-data\",\n  \"type\": \"CUSTOM\",\n  \"entity\": \"Sync\",\n  \"entityPlural\": \"Syncs\",\n  \"icon\": \"<svg xmlns=\\\"http://www.w3.org/2000/svg\\\" fill=\\\"currentColor\\\" class=\\\"bi bi-bar-chart-fill\\\" viewBox=\\\"0 0 16 16\\\">\\n  <path d=\\\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\\\"/>\\n</svg>\",\n  \"metadata\": {\n    \"foo\": \"bar\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example0
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Nightly Data Loads",
  "namespace": "nightly-data",
  "type": "CUSTOM",
  "entity": "Sync",
  "entityPlural": "Syncs",
  "icon": "<svg xmlns=\"http://www.w3.org/2000/svg\" fill=\"currentColor\" class=\"bi bi-bar-chart-fill\" viewBox=\"0 0 16 16\">
  <path d=\"M1 11a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1zm5-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1zm5-5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1z\"/>
</svg>",
  "metadata": ["foo": "bar"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/apps")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```